module Quasar.Network (
  -- * Rpc api definition
  RpcApi,
  RpcFunction,
  RpcArgument,
  RpcResult,
  RpcChannel,
  rpcApi,
  rpcFunction,
  addArgument,
  addResult,
  addChannel,
  setFixedHandler,
  rpcObservable,

  -- * Runtime

  -- ** Client
  Client,
  clientSend,
  clientReportProtocolError,

  withClientTCP,
  withClientUnix,
  withClient,

  -- ** Server
  Server,
  Listener(..),
  runServer,
  withLocalClient,
  listenTCP,
  listenUnix,
  listenOnBoundSocket,

  -- ** Channel
  Channel,
  channelSend,
  channelSetHandler,
  channelSetSimpleHandler,
) where

import Quasar.Network.TH
import Quasar.Network.Runtime
